//CSimpleComboBox.h - A simple combobox (i.e. drop down list and arrow button)

#ifndef CSIMPLECOMBOBOX_H_
#define CSIMPLECOMBOBOX_H_

#include "vstcontrols.h"

class CSimpleComboBox : public COptionMenu
{
  public:
	CSimpleComboBox(CRect &size,
					   CControlListener *listener,
					   long tag,
					   CColor bgcol,
					   CColor fgcol,
					   int style = 0);
	virtual ~CSimpleComboBox() {delete Scheme;};

	virtual void draw(CDrawContext*);

	virtual void mouse(CDrawContext *context, CPoint &where);

	virtual void drawText(CDrawContext *pContext, char *string);
	virtual void takeFocus(CDrawContext *pContext);
	virtual void looseFocus(CDrawContext *pContext);

	virtual void SetColours(CColor bgcol, CColor fgcol, CColor frcol) {BackColour = bgcol; ForeColour = fgcol; FrameColour = frcol;};
  protected:
	bool IsClicked;
	CColor BackColour;
	CColor ForeColour;
	CColor FrameColour;

	COptionMenuScheme *Scheme;
};

#endif