//CSimpleFileSelector.cpp - A proper cross-platform (well, Mac & PC, anyway) file selector.

#include "CSimpleFileSelector.h"

#include <stdio.h>

#ifdef MAC
//**The following taken from http://www.u-he.com/vstsource/archive.php?classid=5#6 , Posted by paul.kellett@mda-vst.com**
#include <Files.h> //Mac-specific stuff
#include <stdio.h>
#include <string.h>

//path2fss makes an FSSpec from a path with or without a filename
int path2fss(FSSpec *fss, char *path)
{
	char buf[256];
	char *p = &buf[1];
	strcpy(p, path); //convert to Str255
	buf[0] = strlen(p);

	return(FSMakeFSSpec(0, 0, (unsigned char *)buf, fss)); //== noErr
}


//fss2path takes the FSSpec of a file, folder or volume and returns it's path
void fss2path(char *path, FSSpec *fss)
{
	int l;             //fss->name contains name of last item in path
	for(l=0; l<(fss->name[0]); l++)
		path[l] = fss->name[l + 1];
	path[l] = 0;

	if(fss->parID != fsRtParID) //path is more than just a volume name
	{
		int i, len;
		CInfoPBRec pb;
    
		pb.dirInfo.ioNamePtr = fss->name;
		pb.dirInfo.ioVRefNum = fss->vRefNum;
		pb.dirInfo.ioDrParID = fss->parID;
		do
		{
			pb.dirInfo.ioFDirIndex = -1;  //get parent directory name
			pb.dirInfo.ioDrDirID = pb.dirInfo.ioDrParID;  
			if(PBGetCatInfoSync(&pb) != noErr)
				break;

			len = fss->name[0] + 1;
			for(i=l; i>=0;  i--)
				path[i + len] = path[i];
			for(i=1; i<len; i++)
				path[i - 1] = fss->name[i]; //add to start of path
			path[i - 1] = ':';
			l += len;
		} while(pb.dirInfo.ioDrDirID != fsRtDirID); //while more directory levels
	}
}
//**
#endif

CSimpleFileSelector::CSimpleFileSelector(AudioEffectX* effect):
CFileSelector(effect)
{
}

bool CSimpleFileSelector::GetFilename(VstFileSelect *vfs, char *inpath, char *retpath)
{
#ifdef MAC
	FSSpec fss1;
	FSSpec fss2;
	path2fss(&fss1, inpath);
        //path2fss(&fss1, "Macintosh HD:Users:niallmoody:Desktop:");
	vfs->initialPath = (char *)&fss1;
	vfs->returnPath = (char *)&fss2;
#elif WIN32
	vfs->initialPath = inpath;
	vfs->returnPath = retpath;
#endif

	if(run(vfs))
	{
#ifdef MAC
		fss2path(retpath, &fss2);
                
                
#elif WIN32
		//strcpy(retval, vstFileSelect.returnPath);
		//retpath = strdup(vstFileSelect->returnPath);

		FILE *fp;
		fp = fopen("D:\\bs2test.txt", "w");
		fprintf(fp, "%d\n", vfs->nbReturnPath);
		fclose(fp);

		
		strcpy(retpath, vfs->returnPath);
#endif

		if((retpath != NULL)||(retpath != ""))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	else
		return false;
}