//CSimpleFrame.cpp - a simple frame which does not take a bitmap as it's background

#include "CSimpleFrame.h"

CSimpleFrame::CSimpleFrame(CRect &size,
						   void *systemWindow,
						   AEffGUIEditor *editorm,
						   CColor col):
					CFrame(size, systemWindow, editorm)
{
	Colour = col;

/*#if WINDOWS

#if USE_GLOBAL_CONTEXT
	/*hdc = GetDC ((HWND)getSystemWindow ());
	#if DEBUG
	gNbDC++;
	#endif*//*

	FrameContext = new CDrawContext (this, hdc, getSystemWindow());
#endif

#elif MAC
	FrameContext = new CDrawContext(this, getSystemWindow(), getSystemWindow());
	FrameContext->offset.h = size.left;
	FrameContext->offset.v = size.top;
	
#elif MOTIF
	FrameContext = new CDrawContext(this, gc, (void*)window);
#endif*/
}

//-----------------------------------------------------------------------------
void CSimpleFrame::draw(CDrawContext *context)
{
	CRect temp2((size.left-1), (size.top-1), (size.right+2), (size.bottom+2));

	if(bFirstDraw)
		bFirstDraw = false;
	
	//if(!context)
		//context = FrameContext; //pFrameContext is private, is it ok to skip it?

	context->setFillColor(Colour);
	context->fillRect(temp2);

	// and the different children
	for(long i=0;i<viewCount;i++)
		ppViews[i]->draw(context);

	// and the modal view
	if(pModalView)
		pModalView->draw(context);
}

//-----------------------------------------------------------------------------
void CSimpleFrame::drawRect(CDrawContext *context, CRect& updateRect)
{
	CRect temp2((size.left-1), (size.top-1), (size.right+2), (size.bottom+2));

	if(bFirstDraw)
		bFirstDraw = false;
	
	//if(!context)
		//context = FrameContext;

	context->setFillColor(Colour);
	context->fillRect(temp2);

	// and the different children
	for(long i=0;i<viewCount;i++)
	{
		if (ppViews[i]->checkUpdate(updateRect))
			ppViews[i]->drawRect(context, updateRect);
	}

	// and the modal view
	if(pModalView && pModalView->checkUpdate(updateRect))
		pModalView->draw(context);
}
