//CSimpleGaugeSlider.cpp - A simple gauge-style slider

#include "CSimpleGaugeSlider.h"

//necessary to build in Project Builder/XCode
#ifndef GLOBALNULL
#define GLOBALNULL
const CRect GlobalNull(0, 0, 0, 0);
CPoint GlobalNull2(0, 0);
#endif

CSimpleGaugeSlider::CSimpleGaugeSlider():
                                    CSlider(GlobalNull,
							(CControlListener *)NULL,
							(long)-1,
							(long)0,
							(long)0,
							(CBitmap *)NULL,
							(CBitmap *)NULL,
							GlobalNull2)
{
}

CSimpleGaugeSlider::CSimpleGaugeSlider(CRect &size,
									   CControlListener *listener,
									   long tag,
									   int style,	//(kBottom,kRight,kTop,kLeft,kHorizontal,kVertical)
									   CColor bgcol,
									   CColor fgcol):
								CSlider(size,
									    listener,
									    tag,
									    size.left,
									    size.right,
										(CBitmap *)0,
										(CBitmap *)0,
									    GlobalNull2,
									    (long)style)
{
	BackColour = bgcol;
	ForeColour = fgcol;
	FrameColour = kBlackCColor;
}

void CSimpleGaugeSlider::Create(CRect &size,
									   CControlListener *listener,
									   long tag,
									   int style,	//(kBottom,kRight,kTop,kLeft,kHorizontal,kVertical)
									   CColor bgcol,
									   CColor fgcol)
{
	//**stuff to make up for not calling CSlider's constructor properly
	this->size = size;
	this->listener = listener;
	setTag(tag);
	this->style = style;

	setDrawTransparentHandle (true);

	if (pHandle)
	{
		pHandle->remember ();
		widthOfSlider  = pHandle->getWidth ();
		heightOfSlider = pHandle->getHeight ();
	}
	else
	{
		widthOfSlider  = 1; 
		heightOfSlider = 1;
	}

	widthControl  = size.width ();
	heightControl = size.height ();

	if (style & kHorizontal)
	{
		minPos = 0 - size.left;
		rangeHandle = 0 - 0;
		CPoint p (0, 0);
		setOffsetHandle (p);
	}
	else
	{
		minPos = 0 - size.top;
		rangeHandle = 0 - 0;
		CPoint p (0, 0);
		setOffsetHandle (p);
	}

	zoomFactor = 10.f;
	//**

	BackColour = bgcol;
	ForeColour = fgcol;
	FrameColour = kBlackCColor;
}

//-----------------------------------------------------------------------------
void CSimpleGaugeSlider::draw(CDrawContext *pContext)
{
	CRect rectGBack;

	COffscreenContext *oc = new COffscreenContext(getParent(), getWidth(), getHeight(), kBlackCColor);

	float fValue;
	if((style & kLeft)||(style & kTop))
		fValue = value;
	else 
		fValue = 1.0f - value;
	
	// (re)draw background
	CRect rect(0, 0, widthControl, heightControl);
	oc->setFillColor(BackColour);
	oc->fillRect(rect);
	rect(0, 0, (widthControl-1), (heightControl-1)); //necessary
	oc->setFrameColor(FrameColour);
	oc->drawRect(rect);
	
	// calc new coords of slider
	CRect   rectNew;
	/*if(style & kHorizontal)
	{
		rectNew.top    = offsetHandle.v;
		rectNew.bottom = rectNew.top + heightOfSlider;	

		rectNew.left   = offsetHandle.h + (int)(fValue * rangeHandle);
		rectNew.left   = (rectNew.left < minTmp) ? minTmp : rectNew.left;

		rectNew.right  = rectNew.left + widthOfSlider;
		rectNew.right  = (rectNew.right > maxTmp) ? maxTmp : rectNew.right;
	}
	else
	{
		rectNew.left   = offsetHandle.h;
		rectNew.right  = rectNew.left + widthOfSlider;	

		rectNew.top    = offsetHandle.v + (int)(fValue * rangeHandle);
		rectNew.top    = (rectNew.top < minTmp) ? minTmp : rectNew.top;

		rectNew.bottom = rectNew.top + heightOfSlider;
		rectNew.bottom = (rectNew.bottom > maxTmp) ? maxTmp : rectNew.bottom;
	}*/

	
	/*if((style & kVertical)&&(style & kTop))
		rectGBack.top = size.top + 1;
	else if((style & kVertical)&&(style & kBottom))
		rectGBack.top = size.top - (offsetHandle.v + (int)(fValue * rangeHandle));
	else
		rectGBack.top = rectNew.top + 1;

	if((style & kHorizontal)&&(style & kLeft))
		rectGBack.left = size.left + 1;
	else if((style & kHorizontal)&&(style & kRight))
		rectGBack.left = size.right - (offsetHandle.v + (int)(fValue * rangeHandle));
	else
		rectGBack.left = rectNew.left+1;

	if((style & kHorizontal)&&(style & kRight))
		rectGBack.right = size.right - 1;
	else if((style & kHorizontal)&&(style & kLeft))
		rectGBack.right = offsetHandle.h + (int)(fValue * rangeHandle);
	else
		rectGBack.right = rectNew.right - 1;

	if((style & kVertical)&&(style & kBottom))
		rectGBack.bottom = size.bottom-1;
	else if((style & kVertical)&&(style & kTop))
		rectGBack.bottom = offsetHandle.v + (int)(fValue * rangeHandle);
	else
		rectGBack.bottom = rectNew.bottom+1;*/

	/*if((style & kHorizontal)&&(style & kLeft))
		rectGBack.right = size.right;*/

	/*if((style & kHorizontal)&&(style & kLeft))
	{
		rectGBack.left = size.left + 2;
		rectGBack.top = size.top + 2;
		rectGBack.right = (int)(fValue * ((size.right - 2)-(size.left + 2)));
		rectGBack.bottom = size.bottom - 2;
	}
	else*/
	if((style & kHorizontal)&&(style & kLeft))
	{
		rectGBack.left = 1;
		rectGBack.top = 1;
		rectGBack.right = ((int)((float)((size.right-1)-(size.left+1)) * (fValue)));
		rectGBack.bottom = ((size.bottom-1)-(size.top+1));

		if(rectGBack.right <= rectGBack.left)
			rectGBack.right = rectGBack.left + 1;
	}
	else if((style & kHorizontal)&&(style & kRight))
	{
		rectGBack.left = ((int)((float)((size.right-1)-(size.left+1)) * fValue))+1;
		rectGBack.top = 1;
		rectGBack.right = (size.right-1)-(size.left+1);
		rectGBack.bottom = ((size.bottom-1)-(size.top+1));

		if(rectGBack.right <= rectGBack.left)
			rectGBack.right = rectGBack.left + 1;
	}
	else if((style & kVertical)&&(style & kBottom))
	{
		rectGBack.left = 1;
		rectGBack.top = ((int)((float)((size.bottom-1)-(size.top+1)) * (fValue)))+1;
		rectGBack.right = (size.right-1)-(size.left+1);
		rectGBack.bottom = ((size.bottom-1)-(size.top+1));

		if(rectGBack.bottom <= rectGBack.top)
			rectGBack.bottom = rectGBack.top + 1;
	}
	else if((style & kVertical)&&(style & kTop))
	{
		rectGBack.left = 1;
		rectGBack.top = 1;
		rectGBack.right = (size.right-1)-(size.left+1);
		rectGBack.bottom = ((int)((float)((size.bottom-1)-(size.top+1)) * (fValue)));

		if(rectGBack.bottom <= rectGBack.top)
			rectGBack.bottom = rectGBack.top + 1;
	}

	oc->setFillColor(ForeColour);
	oc->setFrameColor(ForeColour);
	oc->fillRect(rectGBack);

	oc->copyFrom(pContext, size);
	
	setDirty(false);

	delete oc;
}

void CSimpleGaugeSlider::mouse(CDrawContext *pContext, CPoint &where)
{
	if(!bMouseEnabled)
		return;

	long button = pContext->getMouseButtons();

	// set the default value
	if((button == (kControl|kLButton))||(button == kRButton))
	{
		value = getDefaultValue();
		if(isDirty() && listener)
			listener->valueChanged(pContext, this);
		return;
	}
	
	// allow left mousebutton only
	if(!(button & kLButton))
		return;
	
	float fValue;
	if((style & kLeft)||(style & kTop))
		fValue = value;
	else 
		fValue = 1.0f - value;

	int where_we_are;	//where the gauge is currently set at

	if(style & kHorizontal)
	{
		where_we_are = (size.left+2) + (int)(fValue * (float)((size.right-2)-(size.left+2)));
	}
	else
	{
		where_we_are = (size.top+2) + (int)(fValue * (float)((size.bottom-2)-(size.top+2)));
	}

	float oldVal    = value;
	long  oldButton = button;

	getParent()->beginEdit(tag);
	getParent()->setEditView(this);

	while(1)
	{
		button = pContext->getMouseButtons();
		if(!(button & kLButton))
			break;

		if((oldButton != button)&&(button & kShift))
		{
			oldVal    = value;
			oldButton = button;
		}
		else if(!(button & kShift))
			oldVal = value;

		/*if(style & kHorizontal)
			value = (float)(where.h - where_we_are)/(float)rangeHandle;
		else
			value = (float)(where.v - where_we_are)/(float)rangeHandle;*/

		if(style & kHorizontal)
			where_we_are = where.h;
		else
			where_we_are = where.v;

		if(style & kHorizontal)
			fValue = (float)(where_we_are-(size.left+2))/(float)((size.right-2)-(size.left+2));
		else
			fValue = (float)(where_we_are-(size.top+2))/(float)((size.bottom-2)-(size.top+2));

		if((style & kRight)||(style & kBottom))
			value = 1.0f-fValue;
		else
			value = fValue;

		if(button & kShift)
			value = oldVal + ((value - oldVal)/zoomFactor);
		bounceValue();

		if(isDirty() && listener)
		{
			listener->valueChanged(pContext, this);
		}

		pContext->getMouseLocation(where);

		doIdleStuff();
	}

	// end of edit parameter
	getParent()->endEdit(tag);
}