//CSimpleGaugeSliderBP.cpp - bipolar gauge slider

#include "CSimpleGaugeSliderBP.h"

CSimpleGaugeSliderBP::CSimpleGaugeSliderBP(CRect &size,
									       CControlListener *listener,
										   long tag,
									       int style,
									       CColor bgcol,
									       CColor fgcol):
						CSimpleGaugeSlider(size,
										   listener,
										   tag,
										   style,
										   bgcol,
										   fgcol)
{
	if(style == kHorizontal)
		this->style = kHorizontal|kLeft;
	else if(style == kVertical)
		this->style = kVertical|kBottom;
}

//-----------------------------------------------------------------------------
void CSimpleGaugeSliderBP::draw(CDrawContext *pContext)
{
	CRect rectGBack;

	COffscreenContext *oc = new COffscreenContext(getParent(), getWidth(), getHeight(), kBlackCColor);

	float fValue;
	if(style & kHorizontal)
		fValue = value;
	else 
		fValue = 1.0f - value;
	
	// (re)draw background
	CRect rect(0, 0, widthControl, heightControl);
	oc->setFillColor(BackColour);
	oc->fillRect(rect);
	rect(0, 0, (widthControl-1), (heightControl-1)); //necessary
	oc->setFrameColor(FrameColour);
	oc->drawRect(rect);
	
	// calc new coords of slider
	CRect   rectNew;

	if((style & kHorizontal)&&(fValue > 0.5f))
	{
		rectGBack.left = ((size.right-1)-(size.left+1))/2;
		rectGBack.top = 1;
		rectGBack.right = ((int)((float)((size.right-1)-(size.left+1)) * (fValue)));
		rectGBack.bottom = ((size.bottom-1)-(size.top+1));

		if(rectGBack.right <= rectGBack.left)
			rectGBack.right = rectGBack.left + 1;
	}
	else if((style & kHorizontal)&&(fValue < 0.5f))
	{
		rectGBack.left = ((int)((float)((size.right-1)-(size.left+1)) * (fValue)))+1;
		rectGBack.top = 1;
		rectGBack.right = ((size.right-1)-(size.left+1))/2;
		rectGBack.bottom = ((size.bottom-1)-(size.top+1));

		if(rectGBack.right <= rectGBack.left)
			rectGBack.right = rectGBack.left + 1;
	}
	else if((style & kVertical)&&(fValue < 0.5f))
	{
		rectGBack.left = 1;
		rectGBack.top = ((int)((float)((size.bottom-1)-(size.top+1)) * (fValue)))+1;
		rectGBack.right = (size.right-1)-(size.left+1);
		rectGBack.bottom = ((size.bottom-1)-(size.top+1))/2;

		if(rectGBack.bottom <= rectGBack.top)
			rectGBack.bottom = rectGBack.top + 1;
	}
	else if((style & kVertical)&&(fValue > 0.5f))
	{
		rectGBack.left = 1;
		rectGBack.top = ((size.bottom-1)-(size.top+1))/2;
		rectGBack.right = (size.right-1)-(size.left+1);
		rectGBack.bottom = ((int)((float)((size.bottom-1)-(size.top+1)) * (fValue)));

		if(rectGBack.bottom <= rectGBack.top)
			rectGBack.bottom = rectGBack.top + 1;
	}

	oc->setFillColor(ForeColour);
	oc->setFrameColor(ForeColour);
	oc->fillRect(rectGBack);

	oc->copyFrom(pContext, size);
	
	setDirty(false);

	delete oc;
}