//CSimpleKeyboard.h - Keyboard base class: just draws the keys, basically

#ifndef CSIMPLEKEYBOARD_H_
#define CSIMPLEKEYBOARD_H_

#include "vstcontrols.h"

float round(float val);

class CSimpleKeyboard : public CControl
{
  public:
	CSimpleKeyboard(CRect &size,
					CControlListener *listener,
				    CColor bgcol,
					CColor fgcol,
					int numoctaves = 1);
	virtual ~CSimpleKeyboard() {};

	//virtual bool attached(CView *parent);
	//virtual bool removed(CView *parent);

	virtual void draw(CDrawContext *pContext);

	virtual void DrawKeyboard(CDrawContext *oc, bool *keys);	//takes an array variable (octaves) containing which keys to highlight
											//****note: the order of keys entries is: all the white keys first, then all the black keys****

	virtual void SetColours(CColor bgcol, CColor fgcol, CColor frcol) {BackColour = bgcol; ForeColour = fgcol; FrameColour = frcol;};
  protected:
	//COffscreenContext *OS;
	int NumOctaves;
	CColor BackColour;
	CColor ForeColour;
	CColor FrameColour;
};

#endif