//CSimpleKeyboardSlider.h - A keyboard widget which displays a keyboard with a single key selected (and acts like a slider)

#ifndef CSIMPLEKEYBOARDSLIDER_H_
#define CSIMPLEKEYBOARDSLIDER_H_

#include "CSimpleKeyboard.h"

class CSimpleKeyboardSlider : public CSimpleKeyboard
{
  public:
	CSimpleKeyboardSlider(CRect &size,
						  CControlListener *listener,
						  long tag,
						  CColor bgcol,
						  CColor fgcol,
						  int numoctaves = 1);
	virtual ~CSimpleKeyboardSlider() {};

	virtual void setValue(float val);

	virtual bool attached(CView *parent);
	virtual bool removed(CView *parent);

	virtual void draw(CDrawContext*);
	virtual void mouse(CDrawContext *pContext, CPoint &where);
  protected:
	virtual int ConvertToActualKey(int keyno);

	long NumKeys;
	bool *TempSelectedKey;
};

#endif
