//CSimpleKeyboardSwitch.cpp - Each key acts as a switch, has a tag & value for every key

#include "CSimpleKeyboardSwitch.h"

CSimpleKeyboardSwitch::CSimpleKeyboardSwitch(CRect &size,
											 CControlListener *listener,
											 long *tag,
											 CColor bgcol,
											 CColor fgcol,
											 int numoctaves):
							 CSimpleKeyboard(size,
											 listener,
											 bgcol,
											 fgcol,
											 numoctaves)
{
	int i;

	Tags = new long[(12*NumOctaves)];
	Values = new bool[(12*NumOctaves)];

	for(i=0;i<(12*NumOctaves);i++)
	{
		Tags[i] = tag[i];
		Values[i] = false;
	}

	setTag(Tags[0]);
}

CSimpleKeyboardSwitch::~CSimpleKeyboardSwitch()
{
	delete [] Tags;
	delete [] Values;
}

//-----------------------------------------------------------------------------
void CSimpleKeyboardSwitch::draw(CDrawContext *pContext)
{
	COffscreenContext *oc = new COffscreenContext(getParent(), getWidth(), getHeight(), kBlackCColor);

	DrawKeyboard(oc, Values);

	oc->copyFrom(pContext, size);

	delete oc;
}

//-----------------------------------------------------------------------------
void CSimpleKeyboardSwitch::mouse(CDrawContext *pContext, CPoint &where)
{
	CRect rect;
	int numwhitekeys, numblackkeys;
	int i, i_black;
	int temp1, temp2, temp3;
	bool onthree = false;
	int blackcount;
	int current_octave = 0;
	bool already_black = false;

	if(!bMouseEnabled)
		return;

	long button = pContext->getMouseButtons();

	numwhitekeys = 7 * NumOctaves;
	numblackkeys = 5 * NumOctaves;

	temp1 = (size.right-size.left)/numwhitekeys;

	rect(0, 0, temp1, ((size.bottom-1)-size.top));

	for(i=1;i<numwhitekeys;i++)
	{

		rect.left += temp1;
		rect.right += temp1;
	}

	temp3 = (int)(0.65f * temp1);
	temp2 = (int)(0.65f * ((size.bottom-1)-size.top));

	rect(0, 0, temp3, temp2);
	rect.left += temp1-(temp3/2);
	rect.right = rect.left + temp3;

	rect.offset(size.left, size.top);

	blackcount = 0;
	i_black = numwhitekeys;	//bacause Values is (allthewhitekeys...alltheblackkeys)
	for(i=0;i<(numwhitekeys);i++)
	{
		if((!onthree)&&(blackcount < 2))
		{
			if(rect.pointInside(where))
			{
				if(Values[i_black])
					Values[i_black] = false;
				else
					Values[i_black] = true;

				setTag(Tags[i_black]);
				already_black = true;
				setDirty();
				doIdleStuff();
				if(listener)
					listener->valueChanged(pContext, this);

				break;
			}
			rect.left += temp1;
			rect.right = rect.left + temp3;

			i_black++;
			//i_black++;
			blackcount++;
		}
		else if((!onthree)&&(blackcount < 3))
		{
			rect.left += temp1;
			rect.right = rect.left + temp3;

			//i_black++;
			blackcount = 0;
			onthree = true;
		}
		else if((onthree)&&(blackcount < 3))
		{

			if(rect.pointInside(where))
			{
				if(Values[i_black])
					Values[i_black] = false;
				else
					Values[i_black] = true;

				setTag(Tags[i_black]);
				already_black = true;
				setDirty();
				doIdleStuff();
				if(listener)
					listener->valueChanged(pContext, this);

				break;
			}
			rect.left += temp1;
			rect.right = rect.left + temp3;

			i_black++;
			//i_black++;

			blackcount++;
			//j++;
		}
		else
		{
			rect.left += temp1;
			rect.right = rect.left + temp3;

			//i_black++;
			blackcount = 0;
			onthree = false;
		}
	}
	if(!already_black)
	{
		temp1 = (size.right-size.left)/numwhitekeys;
		rect(0, 0, temp1, ((size.bottom-1)-size.top));
		rect.offset(size.left, size.top);
		for(i=0;i<numwhitekeys;i++)
		{
			if(rect.pointInside(where))
			{
				if(Values[i])
					Values[i] = false;
				else
					Values[i] = true;

				setTag(Tags[i]);
				setDirty();
				doIdleStuff();
				if(listener)
					listener->valueChanged(pContext, this);

				break;
			}

			rect.left += temp1;
			rect.right += temp1;
		}
	}
}