//CSimpleKeyboardSwitch.h - Each key acts as a switch, has a tag & value for every key

#ifndef CSIMPLEKEYBOARDSWITCH_H_
#define CSIMPLEKEYBOARDSWITCH_H_

#include "CSimpleKeyboard.h"

class CSimpleKeyboardSwitch : public CSimpleKeyboard
{
  public:
	CSimpleKeyboardSwitch(CRect &size,
						  CControlListener *listener,
						  long *tag,
						  CColor bgcol,
						  CColor fgcol,
						  int numoctaves = 1);
	virtual ~CSimpleKeyboardSwitch();

	virtual void draw(CDrawContext *pContext);
	virtual void mouse(CDrawContext *pContext, CPoint &where);

	virtual void SetValue(float val, int index)
	{
		if(val < 0.5f)
			Values[index] = false;
		else
			Values[index] = true;

		setDirty();
	}

	virtual float GetValue(int index)
	{
		if(!Values[index])
			return 0.0f;
		else
			return 1.0f;
	}
  protected:
	long *Tags;
	bool *Values;
};

#endif