//CSimpleLamp.cpp - A simple (read-only) lamp class

#include "CSimpleLamp.h"

CSimpleLamp::CSimpleLamp(CRect &size,
						 CControlListener *listener,
						 long tag,
						 CColor bgcol,
						 CColor fgcol):
				CControl(size,
						 listener,
						 tag)
{
	BackColour = bgcol;
	ForeColour = fgcol;
	FrameColour = kBlackCColor;
}

void CSimpleLamp::draw(CDrawContext *pContext)
{
	CRect temp;

	pContext->setFrameColor(FrameColour);
	pContext->drawRect(size);
	pContext->setFillColor(BackColour);
	pContext->fillRect(size);

	if(value > 0.5f)
	{
		pContext->setFillColor(ForeColour);

		temp = size;
		temp.left += 1;
		temp.top += 1;
		temp.right -= 1;
		temp.bottom -= 1;

		pContext->fillRect(temp);
	}
}