//CSimpleParamDisplay.cpp - Simple (editable) Parameter Display

#include "CSimpleParamDisplay.h"
#include <stdio.h>

CSimpleParamDisplay::CSimpleParamDisplay():
					 CTextEdit(CRect(0, 0, 0, 0),
							   0,
							   -1)
{
}

CSimpleParamDisplay::CSimpleParamDisplay(CRect &size,
										 CControlListener *listener,
										 long tag,
										 CColor bgcol,
										 CColor fgcol):
							   CTextEdit(size,
										 listener,
										 tag)
{
	setFontColor(fgcol);
	setBackColor(bgcol);
	setFrameColor(kBlackCColor);
	//setFont(kNormalFontBig);
	setText("0");
}

void CSimpleParamDisplay::Create(CRect &size,
										 CControlListener *listener,
										 long tag,
										 CColor bgcol,
										 CColor fgcol)
{
	this->size = size;
	this->listener = listener;
	setTag(tag);

	setFontColor(fgcol);
	setBackColor(bgcol);
	setFrameColor(kBlackCColor);
	//setFont(kNormalFontBig);
	setText("0");
}

void CSimpleParamDisplay::SetColours(CColor bgcol, CColor fgcol, CColor frcol)
{
	setFontColor(fgcol);
	setBackColor(bgcol);
	setFrameColor(frcol);
}
