//CSimpleTextButton.cpp - Displays text which alters when you click on it (can have any number of text entries)

#include <stdio.h>
#include "CSimpleTextButton.h"

const CRect GlobalNull3(0, 0, 0, 0);
CPoint GlobalNull4(0, 0);

CSimpleTextButton::CSimpleTextButton():
                                    CControl(GlobalNull3,
							(CControlListener *)NULL,
							(long)-1,
							0)
{
}

CSimpleTextButton::CSimpleTextButton(CRect &size,
									 CControlListener *listener,
									 long tag,
									 char texts[][32],
									 long numtext,
									 CColor bgcol,
									 CColor fgcol):
				   CControl(size,
							listener,
							tag)
{
	long i;

	BackColour = bgcol;
	ForeColour = fgcol;
	FrameColour = kBlackCColor;

	NumText = numtext;

	Text = new char *[NumText];

	for(i=0;i<NumText;i++)
	{
		Text[i] = new char[32];	//I'm not entirely sure if this is the right way to allocate an array of strings, but it seems to work...
		strcpy(Text[i], texts[i]);
	}

	Index = 0;
}

void CSimpleTextButton::Create(CRect &size,
									 CControlListener *listener,
									 long tag,
									 char texts[][32],
									 long numtext,
									 CColor bgcol,
									 CColor fgcol)
{
	long i;

	//**stuff to make up for not calling CSlider's constructor properly
	this->size = size;
	this->listener = listener;
	setTag(tag);
	//**

	BackColour = bgcol;
	ForeColour = fgcol;
	FrameColour = kBlackCColor;

	NumText = numtext;

	Text = new char *[NumText];

	for(i=0;i<NumText;i++)
	{
		Text[i] = new char[32];	//I'm not entirely sure if this is the right way to allocate an array of strings, but it seems to work...
		strcpy(Text[i], texts[i]);
	}

	Index = 0;
}

CSimpleTextButton::~CSimpleTextButton()
{
	long i;

	for(i=0;i<NumText;i++)
	{
		delete [] Text[i];
	}

	delete [] Text;
}

void CSimpleTextButton::draw(CDrawContext *pContext)
{
	CRect temp;

	//pContext->setFont(fontID);

	pContext->setFontColor(ForeColour);

	temp = size;

	pContext->setFrameColor(FrameColour);
	pContext->drawRect(temp);

	pContext->setFillColor(BackColour);
	pContext->fillRect(temp);

	drawText(pContext, Text[Index]);
}

//------------------------------------------------------------------------
void CSimpleTextButton::drawText(CDrawContext *pContext, char *string)
{
	CRect temp;

	temp = size;

	setDirty(false);

	pContext->setFontColor(ForeColour);
	pContext->setFont(kNormalFont);
	pContext->drawString(string, temp);
}

//------------------------------------------------------------------------
void CSimpleTextButton::mouse(CDrawContext *pContext, CPoint &where)
{
	long mices;

	mices = pContext->getMouseButtons();

	if(mices & kLButton)
	{
		Index++;

		if(Index >= NumText)
			Index = 0;

		value = (float)Index/(float)(NumText-1);
		if(listener)
			listener->valueChanged(pContext, this);
	}
	else if(mices & kRButton)
	{
		Index--;

		if(Index < 0)
			Index = NumText-1;

		value = (float)Index/(float)(NumText-1);
		if(listener)
			listener->valueChanged(pContext, this);
	}
}